function createCanvas() {
    canvas = document.querySelector("#my_game");

    ctx = canvas.getContext("2d");

    canvasWidth = canvas.width;
    canvasHeight = canvas.clientHeight;


}

function drawBackground(bgColor) {
    ctx.fillStyle = bgColor;
    ctx.fillRect(0, 0, canvasWidth, canvasHeight);
}

function drawGameBoard() {
    ctx.fillStyle = "#908060";
    ctx.fillRect(gameBoard.theX, gameBoard.theY, gameBoard.theWidth, gameBoard.theHeight);
    ctx.strokeRect(gameBoard.theX, gameBoard.theY, gameBoard.theWidth, gameBoard.theHeight);

    soloCell.theWidth = gameBoard.theWidth / gameBoard.theColumns;
    soloCell.theHeight = gameBoard.theHeight / gameBoard.theRows;

    for (let y = 0; y < gameBoard.theRows; y++) {
        for (let x = 0; x < gameBoard.theColumns; x++) {
            soloCell.theX = gameBoard.theX + soloCell.theWidth * x;
            soloCell.theY = gameBoard.theY + soloCell.theWidth * y;
            ctx.strokeRect(soloCell.theX, soloCell.theY, soloCell.theWidth, soloCell.theHeight);

            //         const SLEEP = 0;  //place in array
            // const EAT_FOOD = 1;
            // const CODING = 2;
            // const GRAPHICS_DESIGN = 3;
            // const SOUND_DESIGN = 4;    imgCoding, imgFood, imgGraphics, imgSleep, imgSound;
             let spriteImage;
            switch (gameBoard.boardArray[x][y]) {
                case BLANK_CELL: spriteImage = imgBlankCell;
                    break;
                case SLEEP: spriteImage = imgSleep;
                    break;
                case EAT_FOOD: spriteImage = imgFood; 
                    break;
                case CODING: spriteImage = imgCoding;
                    break;
                case GRAPHICS_DESIGN: spriteImage = imgGraphics;
                    break;
                case SOUND_DESIGN: spriteImage = imgSound;
                    break;
            }

            ctx.drawImage(spriteImage,soloCell.theX, soloCell.theY, soloCell.theWidth, soloCell.theHeight);
        }

    }
}

function drawClock() {
    ctx.fillStyle = "lime";
    ctx.beginPath();
    ctx.arc(gameClock.theX, gameClock.theY, gameClock.theDiameter, 0, 2 * Math.PI, true);
    ctx.fill();

    ctx.font = "36px Arial";
    ctx.fillStyle = gameClock.theTextColor;
     
    ctx.fillText(gameClock.hoursCounter.toString(), gameClock.theX, gameClock.theY);

}

function drawPoints(){
    let points_X = 1000;
    let points_Y = 100;

    ctx.font = "30px Arial";
    ctx.fillStyle = gameClock.theTextColor;
     
    ctx.fillText(gameObj.points, points_X, points_Y);
}

function drawSleepAndFoodChart(){
    ctx.font = "30px Arial";
    ctx.fillStyle = gameClock.theTextColor;
    //sleep 
    ctx.fillText("Sleep: " + gameObj.sleepCounter, gameObj.sleep_X, gameObj.sleep_Y);
    //food
    ctx.fillText("Food: " + gameObj.foodCounter, gameObj.food_X, gameObj.food_Y);
}

function drawGameDeveloperSkills(){
  
  ctx.font = "30px Arial";
  ctx.fillStyle = gameClock.theTextColor;
  //coding 
  ctx.fillText("Coding: " + gameObj.codingScore, gameObj.coding_X, gameObj.coding_Y);
  //design
  ctx.fillText("Design: " + gameObj.graphicsDesignScore, gameObj.graphics_design_X, gameObj.graphics_design_Y);
  //sound
  ctx.fillText("Sound:  " + gameObj.soundDesignScore, gameObj.sound_design_X, gameObj.sound_design_Y);
}

function drawPlayButton() {
    ctx.drawImage(imgPlayButton, playButton.theX, playButton.theY, playButton.theWidth, playButton.theHeight);

}


function drawAllCanvas() {
    drawBackground(canvasBgColor);
    drawGameBoard();
    drawClock();
    drawPoints();
    drawPlayButton();
    drawGameDeveloperSkills();
    drawSleepAndFoodChart();
    gameEnd();
}

function updateClock(){
    if (gameClock.hoursCounter < gameClock.theHoursLimit){
        gameClock.hoursCounter++;
    } else {
        gameObj.boolPlayGame = false;
        gameObj.boolTimeOver = true;
    }
}

function gameEnd(){
    if (gameObj.boolGameOver){
        ctx.font = "30px Arial";
        ctx.fillStyle = gameClock.theTextColor;
    
        ctx.fillText("Game Over", 800,100);
    } else if (gameObj.boolTimeOver){
        ctx.fillText("Time Over", 800,100);
    }
    
}

function loadAllImages() {
    imgPlayButton = new Image();
    imgPlayButton.src = "images/buttons/play_button.png";

    imgBlankCell = new Image();
    imgBlankCell.src = "images/sprites/blank.png";
    imgCoding = new Image();
    imgCoding.src = "images/sprites/coding.png";
    imgFood = new Image();
    imgFood.src = "images/sprites/food.png";
    imgGraphics = new Image();
    imgGraphics.src = "images/sprites/graphics.png";
    imgSleep = new Image();
    imgSleep.src = "images/sprites/sleep.png";
    imgSound = new Image();
    imgSound.src = "images/sprites/sound.png";
    //imgPlayButton.onload = loadeImagesCounter++;
}


function startGame() {
    gameObj.boolPlayGame = true;

    blankBoardArray();
    updateBoardArray();
    
    restartGameVariables();
    clockInterval = setInterval(updateClock, gameClock.theTimeInterval);
    
}


function restartGameVariables(){
    gameObj.points = 0;

    gameObj.boolPlayGame = true;
    gameObj.boolGameOver = false;
    gameObj.boolTimeOver = false;
    gameObj.hoursCounter = 0;
}






/////////////////

function checkMouse() {
    //board
        // check board only if game is active
    if ((gameObj.boolPlayGame) && (checkMouseClickOnSingleObj(gameBoard.theX, gameBoard.theY, gameBoard.theWidth, gameBoard.theHeight, "game board"))) {
        console.log("BOARD!!!");
        gameBoard.clickedCellX = Math.floor((mouseObj.theX - gameBoard.theX)/soloCell.theWidth);  
        gameBoard.clickedCellY = Math.floor((mouseObj.theY - gameBoard.theY)/soloCell.theHeight);
        console.log("gameBoard.clickedCellX  = " + gameBoard.clickedCellX );
        cellClick(gameBoard.clickedCellX, gameBoard.clickedCellY);
    }
    //play button
    else if (checkMouseClickOnSingleObj(playButton.theX, playButton.theY, playButton.theWidth, playButton.theHeight, "play button")) {
        startGame();
        console.log("Start Game!");
    }
}

function checkMouseClickOnSingleObj(obj_X, obj_Y, objWidth, objHeight, objName) {
    if ((mouseObj.theX > obj_X) && (mouseObj.theX < obj_X + objWidth) && (mouseObj.theY > obj_Y) && (mouseObj.theY < obj_Y + objHeight)) {
        console.log(objName + " pressed");
        return true;

    }
    return false;
}